
/*
 * Texture.h
 */
#ifndef TEXTURE_H
#define TEXTURE_H 1

typedef enum {
   OBJECT,
   SPRITE,
   TILE
   } TextureType;

typedef enum {
   RECTANGLE,
   TRIANGLE
   } TexturePolygonType;

typedef struct {
   TextureType        Type;         // what sort of texture is this (OBJECT, SPRITE, TILE)
   int                TextureNumber; // which texture number
   TexturePolygonType PolygonType;  // attached to what type of polygon (RECTANGLE, TRIANGLE)
   bitu8              *Data;        // pointer to textile data
   bitu16             *Data16;      // pointer to 16-bit textile data
   int                x,            // x offset
                      y;            // y offset
   int                Width,        // width
                      Height;       // height
   tr2_colour         *Palette;     // pointer to 256-colour palette
   } texture;

texture *GetTextureInfo(TR2_Level *Level, TextureType Type, int Number, TexturePolygonType poly_type);
double AdjustTextureCoordinate(bitu8 pixel, bit8 offset);

#define TEXTURE_COORDINATE_SCALE    256.0

#endif // TEXTURE_H
